/* Specification of a scenario for
   the echo algorithm in Alloy 6
	 using the specification in module echo_var
   author: Burkhardt Renz, Nocember 2021
*/
open echo_var

pred exampleGraph [N0, N1, N2, N3, N4, N5, N6: Node] {
	Node = N0 + N1 + N2 + N3 + N4 + N5 + N6
	neighbors = N0->N2 + N0->N3 + 
              N1->N2 + N1->N3 +
              N2->N0 + N2->N1 + N2->N3 + N2->N4 +
              N3->N0 + N3->N1 + N3->N2 + N3->N4 + N3->N5 +
              N4->N2 + N4->N3 + N4->N6 +
              N5->N3 + N5->N6 +
              N6->N4 + N6->N5
}

run Scenario {
	some disj N0, N1, N2, N3, N4, N5, N6: Node {
		exampleGraph[N0, N1, N2, N3, N4, N5, N6]
		
		initiate[N2]
		; forward[N0, N2]
		; forward[N4, N2]
		; forward[N3, N4]
		; forward[N1, N3]
		; forward[N6, N4]
		; forward[N5, N3]
		; echo[N5]
		; echo[N6]
		; echo[N1]
		; echo[N3]
		; echo[N4]
		; echo[N0]
		; echo[N2]
		; always stutter
	}
} for 7 Node, 15 steps
 
	
							
